﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Reflection;

namespace WMDIOAPP
{
    public partial class Form1 : Form
    {
        private string sVersion = "Digital I/O Control Demo App " + "V" + Assembly.GetExecutingAssembly().GetName().Version.ToString();
        public enum GPIO_BIT
        {
            PIN3 = 0x0001,
            PIN4 = 0x0002,
            PIN5 = 0x0004,
            PIN6 = 0x0008,
            PIN7 = 0x0010,
            PIN8 = 0x0020,
            PIN9 = 0x0040,
            PIN10 = 0x0080,
            PIN11 = 0x0100,
            PIN12 = 0x0200,
            PIN13 = 0x0400,
            PIN14 = 0x0800
        };

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            WMDIO.WM_GpioClose();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.Text = sVersion;

            if (!WMDIO.WM_GpioOpen())
            {
                MessageBox.Show("WMDIO Driver not install.", "Warning");
                Environment.Exit(1);
            }

            CheckDIDO_Direction();
            CheckDIDO_Status();

        }
        private void SetDir_Click(object sender, EventArgs e)
        {
            SetDIDO_Direction();
        }

        private void SetSt_Click(object sender, EventArgs e)
        {
            SetDIDO_Status();
        }

        private void GetSt_Click(object sender, EventArgs e)
        {
            CheckDIDO_Status();
        }

        private void SetDIDO_Status()
        {
            UInt16 DIDOst = 0x000;

            if (PIN3High.Checked)
            {
                DIDOst |= (ushort)GPIO_BIT.PIN3;
            }

            if (PIN4High.Checked)
            {
                DIDOst |= (ushort)GPIO_BIT.PIN4;
            }

            if (PIN5High.Checked)
            {
                DIDOst |= (ushort)GPIO_BIT.PIN5;
            }

            if (PIN6High.Checked)
            {
                DIDOst |= (ushort)GPIO_BIT.PIN6;
            }

            if (PIN7High.Checked)
            {
                DIDOst |= (ushort)GPIO_BIT.PIN7;
            }

            if (PIN8High.Checked)
            {
                DIDOst |= (ushort)GPIO_BIT.PIN8;
            }

            if (PIN9High.Checked)
            {
                DIDOst |= (ushort)GPIO_BIT.PIN9;
            }

            if (PIN10High.Checked)
            {
                DIDOst |= (ushort)GPIO_BIT.PIN10;
            }

            if (PIN11High.Checked)
            {
                DIDOst |= (ushort)GPIO_BIT.PIN11;
            }
   
            if (PIN12High.Checked)
            {
                DIDOst |= (ushort)GPIO_BIT.PIN12;
            }
       
            if (PIN13High.Checked)
            {
                DIDOst |= (ushort)GPIO_BIT.PIN13;
            }

            if (PIN14High.Checked)
            {
                DIDOst |= (ushort)GPIO_BIT.PIN14;
            }
       
            WMDIO.WM_SetGpioData(DIDOst);
        }

        private void SetDIDO_Direction()
        {
            UInt16 DIDOdir = 0x0000;

            if (PIN3In.Checked)
            {
                DIDOdir |= (ushort)GPIO_BIT.PIN3;
            }

            if (PIN4In.Checked)
            {
                DIDOdir |= (ushort)GPIO_BIT.PIN4;
            } 

            if (PIN5In.Checked)
            {
                DIDOdir |= (ushort)GPIO_BIT.PIN5;
            }

            if (PIN6In.Checked)
            {
                DIDOdir |= (ushort)GPIO_BIT.PIN6;
            }

            if (PIN7In.Checked)
            {
                DIDOdir |= (ushort)GPIO_BIT.PIN7;
            }

            if (PIN8In.Checked)
            {
                DIDOdir |= (ushort)GPIO_BIT.PIN8;
            }

            if (PIN9In.Checked)
            {
                DIDOdir |= (ushort)GPIO_BIT.PIN9;
            }

            if (PIN10In.Checked)
            {
                DIDOdir |= (ushort)GPIO_BIT.PIN10;
            }

            if (PIN11In.Checked)
            {
                DIDOdir |= (ushort)GPIO_BIT.PIN11;
            }

            if (PIN12In.Checked)
            {
                DIDOdir |= (ushort)GPIO_BIT.PIN12;
            }

            if (PIN13In.Checked)
            {
                DIDOdir |= (ushort)GPIO_BIT.PIN13;
            }

            if (PIN14In.Checked)
            {
                DIDOdir |= (ushort)GPIO_BIT.PIN14;
            }

            WMDIO.WM_SetGpioDirection(DIDOdir);
        }

        private void CheckDIDO_Status()
        {
            UInt16 DIDOSt;

            if (WMDIO.WM_GetGpioData(out DIDOSt))
            {
                //MessageBox.Show(String.Format( String.Format("DIDOSt = 0x{0:X}", DIDOSt),"Message"));

                if ((DIDOSt & (ushort)GPIO_BIT.PIN3) == (ushort)GPIO_BIT.PIN3)
                {
                    PIN3High.Checked = true;
                }
                else
                {
                    PIN3Low.Checked = true;
                }

                if ((DIDOSt & (ushort)GPIO_BIT.PIN4) == (ushort)GPIO_BIT.PIN4)
                {
                    PIN4High.Checked = true;
                }
                else
                {
                    PIN4Low.Checked = true;
                }

                if ((DIDOSt & (ushort)GPIO_BIT.PIN5) == (ushort)GPIO_BIT.PIN5)
                {
                    PIN5High.Checked = true;
                }
                else
                {
                    PIN5Low.Checked = true;
                }

                if ((DIDOSt & (ushort)GPIO_BIT.PIN6) == (ushort)GPIO_BIT.PIN6)
                {
                    PIN6High.Checked = true;
                }
                else
                {
                    PIN6Low.Checked = true;
                }

                if ((DIDOSt & (ushort)GPIO_BIT.PIN7) == (ushort)GPIO_BIT.PIN7)
                {
                    PIN7High.Checked = true;
                }
                else
                {
                    PIN7Low.Checked = true;
                }

                if ((DIDOSt & (ushort)GPIO_BIT.PIN8) == (ushort)GPIO_BIT.PIN8)
                {
                    PIN8High.Checked = true;
                }
                else
                {
                    PIN8Low.Checked = true;
                }

                if ((DIDOSt & (ushort)GPIO_BIT.PIN9) == (ushort)GPIO_BIT.PIN9)
                {
                    PIN9High.Checked = true;
                }
                else
                {
                    PIN9Low.Checked = true;
                }

                if ((DIDOSt & (ushort)GPIO_BIT.PIN10) == (ushort)GPIO_BIT.PIN10)
                {
                    PIN10High.Checked = true;
                }
                else
                {
                    PIN10Low.Checked = true;
                }

                if ((DIDOSt & (ushort)GPIO_BIT.PIN11) == (ushort)GPIO_BIT.PIN11)
                {
                    PIN11High.Checked = true;
                }
                else
                {
                    PIN11Low.Checked = true;
                }

                if ((DIDOSt & (ushort)GPIO_BIT.PIN12) == (ushort)GPIO_BIT.PIN12)
                {
                    PIN12High.Checked = true;
                }
                else
                {
                    PIN12Low.Checked = true;
                }

                if ((DIDOSt & (ushort)GPIO_BIT.PIN13) == (ushort)GPIO_BIT.PIN13)
                {
                    PIN13High.Checked = true;
                }
                else
                {
                    PIN13Low.Checked = true;
                }

                if ((DIDOSt & (ushort)GPIO_BIT.PIN14) == (ushort)GPIO_BIT.PIN14)
                {
                    PIN14High.Checked = true;
                }
                else
                {
                    PIN14Low.Checked = true;
                }
            }
        }
        private void CheckDIDO_Direction()
        {
            UInt16 DIDOdir;

            if (WMDIO.WM_GetGpioDirection(out DIDOdir))
            {
                //MessageBox.Show(String.Format(String.Format("DIDOdir = 0x{0:X}", DIDOdir), "Message"));

                if ((DIDOdir & (ushort)GPIO_BIT.PIN3) == (ushort)GPIO_BIT.PIN3)
                {
                    PIN3Out.Checked = true;
                }
                else
                {
                    PIN3In.Checked = true;
                }

                if ((DIDOdir & (ushort)GPIO_BIT.PIN4) == (ushort)GPIO_BIT.PIN4)
                {
                    PIN4Out.Checked = true;
                }
                else
                {
                    PIN4In.Checked = true;
                }

                if ((DIDOdir & (ushort)GPIO_BIT.PIN5) == (ushort)GPIO_BIT.PIN5)
                {
                    PIN5Out.Checked = true;
                }
                else
                {
                    PIN5In.Checked = true;
                }

                if ((DIDOdir & (ushort)GPIO_BIT.PIN6) == (ushort)GPIO_BIT.PIN6)
                {
                    PIN6Out.Checked = true;
                }
                else
                {
                    PIN6In.Checked = true;
                }

                if ((DIDOdir & (ushort)GPIO_BIT.PIN7) == (ushort)GPIO_BIT.PIN7)
                {
                    PIN7Out.Checked = true;
                }
                else
                {
                    PIN7In.Checked = true;
                }

                if ((DIDOdir & (ushort)GPIO_BIT.PIN8) == (ushort)GPIO_BIT.PIN8)
                {
                    PIN8Out.Checked = true;
                }
                else
                {
                    PIN8In.Checked = true;
                }

                if ((DIDOdir & (ushort)GPIO_BIT.PIN9) == (ushort)GPIO_BIT.PIN9)
                {
                    PIN9Out.Checked = true;
                }
                else
                {
                    PIN9In.Checked = true;
                }

                if ((DIDOdir & (ushort)GPIO_BIT.PIN10) == (ushort)GPIO_BIT.PIN10)
                {
                    PIN10Out.Checked = true;
                }
                else
                {
                    PIN10In.Checked = true;
                }

                if ((DIDOdir & (ushort)GPIO_BIT.PIN11) == (ushort)GPIO_BIT.PIN11)
                {
                    PIN11Out.Checked = true;
                }
                else
                {
                    PIN11In.Checked = true;
                }

                if ((DIDOdir & (ushort)GPIO_BIT.PIN12) == (ushort)GPIO_BIT.PIN12)
                {
                    PIN12Out.Checked = true;
                }
                else
                {
                    PIN12In.Checked = true;
                }

                if ((DIDOdir & (ushort)GPIO_BIT.PIN13) == (ushort)GPIO_BIT.PIN13)
                {
                    PIN13Out.Checked = true;
                }
                else
                {
                    PIN13In.Checked = true;
                }

                if ((DIDOdir & (ushort)GPIO_BIT.PIN14) == (ushort)GPIO_BIT.PIN14)
                {
                    PIN14Out.Checked = true;
                }
                else
                {
                    PIN14In.Checked = true;
                }
            }
        }
        private void Group1_Status_Checked(object sender, EventArgs e)
        {
            CheckBox cb = (CheckBox)sender;
            int i = -1;
            string name = string.Empty;
            string status = string.Empty;

            i = cb.Name.IndexOf("In");
            if (i >= 0)
            {
                status = "In";
                name = cb.Name.Substring(0, i);
            }
            else
            {
                i = cb.Name.IndexOf("Out");
                if (i >= 0)
                {
                    status = "Out";
                    name = cb.Name.Substring(0, i);
                }
            }

            foreach (Control ctrl in this.groupBox1.Controls)
            {
                if (cb.Checked)
                {
                    if (status == "Out")
                    {
                        if (ctrl.Name == name + "In")
                        {
                            CheckBox ck = (CheckBox)ctrl;
                            ck.Checked = false;
                        }
                    }
                    else if (status == "In")
                    {
                        if (ctrl.Name == name + "Out")
                        {
                            CheckBox ck = (CheckBox)ctrl;
                            ck.Checked = false;
                        }
                    }
                }
                else
                {
                    if (status == "Out")
                    {
                        if (ctrl.Name == name + "In")
                        {
                            CheckBox ck = (CheckBox)ctrl;
                            ck.Checked = true;
                        }
                    }
                    else if (status == "In")
                    {
                        if (ctrl.Name == name + "Out")
                        {
                            CheckBox ck = (CheckBox)ctrl;
                            ck.Checked = true;
                        }
                    }
                }
            }
        }
        private void Group2_Status_Checked(object sender, EventArgs e)
        {
            CheckBox cb = (CheckBox)sender;
            int i = -1;
            string name = string.Empty;
            string status = string.Empty;

            i = cb.Name.IndexOf("High");
            if (i >= 0)
            {
                status = "High";
                name = cb.Name.Substring(0, i);
            }
            else
            {
                i = cb.Name.IndexOf("Low");
                if (i >= 0)
                {
                    status = "Low";
                    name = cb.Name.Substring(0, i);
                }
            }

            foreach (Control ctrl in this.groupBox2.Controls)
            {
                if (cb.Checked)
                {
                    if (status == "Low")
                    {
                        if (ctrl.Name == name + "High")
                        {
                            CheckBox ck = (CheckBox)ctrl;
                            ck.Checked = false;
                        }
                    }
                    else if (status == "High")
                    {
                        if (ctrl.Name == name + "Low")
                        {
                            CheckBox ck = (CheckBox)ctrl;
                            ck.Checked = false;
                        }
                    }
                }
                else
                {
                    if (status == "Low")
                    {
                        if (ctrl.Name == name + "High")
                        {
                            CheckBox ck = (CheckBox)ctrl;
                            ck.Checked = true;
                        }
                    }
                    else if (status == "High")
                    {
                        if (ctrl.Name == name + "Low")
                        {
                            CheckBox ck = (CheckBox)ctrl;
                            ck.Checked = true;
                        }
                    }
                }
            }
        }


    }
}